codeforces 217A 连通块的个数

题目:

A. Ice Skating
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Bajtek is learning to skate on ice. He's a beginner, so his only mode of transportation is pushing off from a snow drift to the north, east, south or west and sliding until he lands in another snow drift. He has noticed that in this way it's impossible to get from some snow drifts to some other by any sequence of moves. He now wants to heap up some additional snow drifts, so that he can get from any snow drift to any other one. He asked you to find the minimal number of snow drifts that need to be created.

We assume that Bajtek can only heap up snow drifts at integer coordinates.

Input

The first line of input contains a single integer n (1 ≤ n ≤ 100) — the number of snow drifts. Each of the following n lines contains two integers xi and yi (1 ≤ xi, yi ≤ 1000) — the coordinates of the i-th snow drift.

Note that the north direction coinсides with the direction of Oy axis, so the east direction coinсides with the direction of the Ox axis. All snow drift's locations are distinct.

Output

Output the minimal number of snow drifts that need to be created in order for Bajtek to be able to reach any snow drift from any other one.

Examples
input
2
2 1
1 2
output
1
input
2
2 1
4 1
output
0

给出n个点的横纵坐标,问至少再加几个点可以使得所有的点之间可以通过上下左右走互相到达


思路:

若两个点横坐标或者纵坐标相同,两点间连一条边 通过dfs统计连通块的个数

当然并查集也是可以的,但由于不涉及给出任意两个点判断是否连通,因此dfs更轻便


代码:

dfs:

#include<bits/stdc++.h>
#include<queue>
using namespace std;
const int maxn=120;
const __int64 inf=(__int64)1<<62;

struct edge {
	int id;
	int x;
	int y;
}e[maxn];
int g[maxn][maxn];
int vis[maxn];
int m,ans;

void dfs(int x) {
	vis[x]=1;
	for(int j=1;j<=m;++j) {
		if(!vis[j]) if(g[x][j]) dfs(j);
	}
}

int main() {//30 ms	200 KB
	scanf("%d",&m);
	for(int i=1;i<=m;++i) {
		scanf("%d%d",&e[i].x,&e[i].y);
		e[i].id=i;
	}
	memset(g,0,sizeof(g));
	for(int i=1;i<=m;++i) {
		for(int j=1;j<=i;++j) {
			if(e[i].x==e[j].x||e[i].y==e[j].y) g[i][j]=g[j][i]=1;
		}
	}
	ans=-1;
	memset(vis,0,sizeof(vis));
	for(int i=1;i<=m;++i) {
		if(!vis[i]) dfs(i),ans++;
	}
	printf("%d\n",ans);
	return 0;
}



....额 好像只要假装建图就可以了....

#include<bits/stdc++.h>
#include<queue>
using namespace std;
const int maxn=120;
const __int64 inf=(__int64)1<<62;

struct edge {
	int x;
	int y;
}e[maxn];
int vis[maxn];
int m,ans;

void dfs(int x) {
	vis[x]=1;
	for(int j=1;j<=m;++j) {
		if(!vis[j]) if(e[x].x==e[j].x||e[x].y==e[j].y) dfs(j);
	}
}

int main() {//30 ms	100 KB
	scanf("%d",&m);
	for(int i=1;i<=m;++i) {
		scanf("%d%d",&e[i].x,&e[i].y);
	}
	ans=-1;
	memset(vis,0,sizeof(vis));
	for(int i=1;i<=m;++i) {
		if(!vis[i]) dfs(i),ans++;
	}
	printf("%d\n",ans);
	return 0;
}

并查集实现思路:两个点横后者纵坐标相同就union,最后统计有几个不相交集,即有几个点的fa[i]==i,



  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值